[PATCH 3/3] perf test: Add test of libpfm4 events

From: Namhyung Kim
Date: Thu Jun 08 2023 - 19:24:18 EST


From: Ian Rogers <irogers@xxxxxxxxxx>

$ ./perf test -v 102
102: perf all libpfm4 events test :
--- start ---
test child forked, pid 3030994
Testing ix86arch::UNHALTED_CORE_CYCLES
Testing ix86arch::INSTRUCTION_RETIRED
Testing ix86arch::UNHALTED_REFERENCE_CYCLES
Testing ix86arch::LLC_REFERENCES
Testing ix86arch::LLC_MISSES
Testing ix86arch::BRANCH_INSTRUCTIONS_RETIRED
Testing ix86arch::MISPREDICTED_BRANCH_RETIRED
Testing perf_raw::r0000
Testing icl::UNHALTED_CORE_CYCLES
Testing icl::UNHALTED_REFERENCE_CYCLES
...
test child finished with 0
---- end ----
perf all libpfm4 events test: Ok

Signed-off-by: Ian Rogers <irogers@xxxxxxxxxx>
Signed-off-by: Namhyung Kim <namhyung@xxxxxxxxxx>
---
tools/perf/tests/shell/stat_all_pfm.sh | 51 ++++++++++++++++++++++++++
1 file changed, 51 insertions(+)
create mode 100755 tools/perf/tests/shell/stat_all_pfm.sh

diff --git a/tools/perf/tests/shell/stat_all_pfm.sh b/tools/perf/tests/shell/stat_all_pfm.sh
new file mode 100755
index 000000000000..4d004f777a6e
--- /dev/null
+++ b/tools/perf/tests/shell/stat_all_pfm.sh
@@ -0,0 +1,51 @@
+#!/bin/sh
+# perf all libpfm4 events test
+# SPDX-License-Identifier: GPL-2.0
+
+if perf version --build-options | grep HAVE_LIBPFM | grep -q OFF
+then
+ echo "Skipping, no libpfm4 support"
+ exit 2
+fi
+
+err=0
+for p in $(perf list --raw-dump pfm)
+do
+ if echo "$p" | grep -q unc_
+ then
+ echo "Skipping uncore event '$p' that may require additional options."
+ continue
+ fi
+ echo "Testing $p"
+ result=$(perf stat --pfm-events "$p" true 2>&1)
+ x=$?
+ if echo "$result" | grep -q "failed to parse event $p : invalid or missing unit mask"
+ then
+ continue
+ fi
+ if test "$x" -ne "0"
+ then
+ echo "Unexpected exit code '$x'"
+ err=1
+ fi
+ if ! echo "$result" | grep -q "$p" && ! echo "$result" | grep -q "<not supported>"
+ then
+ # We failed to see the event and it is supported. Possibly the workload was
+ # too small so retry with something longer.
+ result=$(perf stat --pfm-events "$p" perf bench internals synthesize 2>&1)
+ x=$?
+ if test "$x" -ne "0"
+ then
+ echo "Unexpected exit code '$x'"
+ err=1
+ fi
+ if ! echo "$result" | grep -q "$p"
+ then
+ echo "Event '$p' not printed in:"
+ echo "$result"
+ err=1
+ fi
+ fi
+done
+
+exit "$err"
--
2.41.0.162.gfafddb0af9-goog